var tt = Object.defineProperty;
var nt = (n, e, t) => e in n ? tt(n, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : n[e] = t;
var B = (n, e, t) => nt(n, typeof e != "symbol" ? e + "" : e, t);
import { openBlock as se, createElementBlock as le, getCurrentScope as rt, onScopeDispose as at, unref as ot, computed as Fe, watch as Ge, ref as K, getCurrentInstance as it, onMounted as Ie, defineComponent as st, reactive as Ae, shallowRef as Ve, nextTick as lt, toRaw as ct, normalizeClass as $e, createElementVNode as J, normalizeStyle as ut, createCommentVNode as Be, createVNode as ft, createTextVNode as dt } from "vue";
const ht = (n, e) => {
  const t = n.__vccOpts || n;
  for (const [r, a] of e)
    t[r] = a;
  return t;
}, pt = {}, gt = { class: "cf-player__loader" };
function vt(n, e) {
  return se(), le("div", gt);
}
const mt = /* @__PURE__ */ ht(pt, [["render", vt]]);
/**
  postmate - A powerful, simple, promise-based postMessage library
  @version v1.6.0
  @link https://github.com/dollarshaveclub/postmate
  @author Jacob Kelley <jakie8@gmail.com>
  @license MIT
**/
var R = "application/x-postmate-v1+json", yt = 5, wt = 0, bt = function() {
  return ++wt;
}, x = function() {
  var e;
  return k.debug ? (e = console).log.apply(e, arguments) : null;
}, Et = function(e) {
  var t = document.createElement("a");
  t.href = e;
  var r = t.protocol.length > 4 ? t.protocol : window.location.protocol, a = t.host.length ? t.port === "80" || t.port === "443" ? t.hostname : t.host : window.location.host;
  return t.origin || r + "//" + a;
}, Pt = {
  handshake: 1,
  "handshake-reply": 1,
  call: 1,
  emit: 1,
  reply: 1,
  request: 1
  /**
   * Ensures that a message is safe to interpret
   * @param  {Object} message The postmate message being sent
   * @param  {String|Boolean} allowedOrigin The whitelisted origin or false to skip origin check
   * @return {Boolean}
   */
}, De = function(e, t) {
  return !(typeof t == "string" && e.origin !== t || !e.data || typeof e.data == "object" && !("postmate" in e.data) || e.data.type !== R || !Pt[e.data.postmate]);
}, xt = function(e, t) {
  var r = typeof e[t] == "function" ? e[t]() : e[t];
  return k.Promise.resolve(r);
}, Ot = /* @__PURE__ */ function() {
  function n(t) {
    var r = this;
    this.parent = t.parent, this.frame = t.frame, this.child = t.child, this.childOrigin = t.childOrigin, this.events = {}, process.env.NODE_ENV !== "production" && (x("Parent: Registering API"), x("Parent: Awaiting messages...")), this.listener = function(a) {
      if (!De(a, r.childOrigin)) return !1;
      var i = ((a || {}).data || {}).value || {}, o = i.data, s = i.name;
      a.data.postmate === "emit" && (process.env.NODE_ENV !== "production" && x("Parent: Received event emission: " + s), s in r.events && r.events[s].forEach(function(c) {
        c.call(r, o);
      }));
    }, this.parent.addEventListener("message", this.listener, !1), process.env.NODE_ENV !== "production" && x("Parent: Awaiting event emissions from Child");
  }
  var e = n.prototype;
  return e.get = function(r) {
    var a = this;
    return new k.Promise(function(i) {
      var o = bt(), s = function c(p) {
        p.data.uid === o && p.data.postmate === "reply" && (a.parent.removeEventListener("message", c, !1), i(p.data.value));
      };
      a.parent.addEventListener("message", s, !1), a.child.postMessage({
        postmate: "request",
        type: R,
        property: r,
        uid: o
      }, a.childOrigin);
    });
  }, e.call = function(r, a) {
    this.child.postMessage({
      postmate: "call",
      type: R,
      property: r,
      data: a
    }, this.childOrigin);
  }, e.on = function(r, a) {
    this.events[r] || (this.events[r] = []), this.events[r].push(a);
  }, e.destroy = function() {
    process.env.NODE_ENV !== "production" && x("Parent: Destroying Postmate instance"), window.removeEventListener("message", this.listener, !1), this.frame.parentNode.removeChild(this.frame);
  }, n;
}(), At = /* @__PURE__ */ function() {
  function n(t) {
    var r = this;
    this.model = t.model, this.parent = t.parent, this.parentOrigin = t.parentOrigin, this.child = t.child, process.env.NODE_ENV !== "production" && (x("Child: Registering API"), x("Child: Awaiting messages...")), this.child.addEventListener("message", function(a) {
      if (De(a, r.parentOrigin)) {
        process.env.NODE_ENV !== "production" && x("Child: Received request", a.data);
        var i = a.data, o = i.property, s = i.uid, c = i.data;
        if (a.data.postmate === "call") {
          o in r.model && typeof r.model[o] == "function" && r.model[o](c);
          return;
        }
        xt(r.model, o).then(function(p) {
          return a.source.postMessage({
            property: o,
            postmate: "reply",
            type: R,
            uid: s,
            value: p
          }, a.origin);
        });
      }
    });
  }
  var e = n.prototype;
  return e.emit = function(r, a) {
    process.env.NODE_ENV !== "production" && x('Child: Emitting Event "' + r + '"', a), this.parent.postMessage({
      postmate: "emit",
      type: R,
      value: {
        name: r,
        data: a
      }
    }, this.parentOrigin);
  }, n;
}(), k = /* @__PURE__ */ function() {
  function n(t) {
    var r = t.container, a = r === void 0 ? typeof a < "u" ? a : document.body : r, i = t.model, o = t.url, s = t.name, c = t.classListArray, p = c === void 0 ? [] : c, y = t.frame;
    return this.parent = window, y ? this.frame = y : (this.frame = document.createElement("iframe"), this.frame.name = s || "", this.frame.classList.add.apply(this.frame.classList, p)), a.appendChild(this.frame), this.child = this.frame.contentWindow || this.frame.contentDocument.parentWindow, this.model = i || {}, this.sendHandshake(o);
  }
  var e = n.prototype;
  return e.sendHandshake = function(r) {
    var a = this, i = Et(r), o = 0, s;
    return new n.Promise(function(c, p) {
      var y = function A(M) {
        return De(M, i) ? M.data.postmate === "handshake-reply" ? (clearInterval(s), process.env.NODE_ENV !== "production" && x("Parent: Received handshake reply from Child"), a.parent.removeEventListener("message", A, !1), a.childOrigin = M.origin, process.env.NODE_ENV !== "production" && x("Parent: Saving Child origin", a.childOrigin), c(new Ot(a))) : (process.env.NODE_ENV !== "production" && x("Parent: Invalid handshake reply"), p("Failed handshake")) : !1;
      };
      a.parent.addEventListener("message", y, !1);
      var m = function() {
        o++, process.env.NODE_ENV !== "production" && x("Parent: Sending handshake attempt " + o, {
          childOrigin: i
        }), a.child.postMessage({
          postmate: "handshake",
          type: R,
          model: a.model
        }, i), o === yt && clearInterval(s);
      }, w = function() {
        m(), s = setInterval(m, 500);
      };
      a.frame.attachEvent ? a.frame.attachEvent("onload", w) : a.frame.addEventListener("load", w), process.env.NODE_ENV !== "production" && x("Parent: Loading frame", {
        url: r
      }), a.frame.src = r;
    });
  }, n;
}();
k.debug = !1;
k.Promise = function() {
  try {
    return window ? window.Promise : Promise;
  } catch {
    return null;
  }
}();
k.Model = /* @__PURE__ */ function() {
  function n(t) {
    return this.child = window, this.model = t, this.parent = this.child.parent, this.sendHandshakeReply();
  }
  var e = n.prototype;
  return e.sendHandshakeReply = function() {
    var r = this;
    return new k.Promise(function(a, i) {
      var o = function s(c) {
        if (c.data.postmate) {
          if (c.data.postmate === "handshake") {
            process.env.NODE_ENV !== "production" && x("Child: Received handshake from Parent"), r.child.removeEventListener("message", s, !1), process.env.NODE_ENV !== "production" && x("Child: Sending handshake reply to Parent"), c.source.postMessage({
              postmate: "handshake-reply",
              type: R
            }, c.origin), r.parentOrigin = c.origin;
            var p = c.data.model;
            return p && (Object.keys(p).forEach(function(y) {
              r.model[y] = p[y];
            }), process.env.NODE_ENV !== "production" && x("Child: Inherited and extended model from Parent")), process.env.NODE_ENV !== "production" && x("Child: Saving Parent origin", r.parentOrigin), a(new At(r));
          }
          return i("Handshake Reply Failed");
        }
      };
      r.child.addEventListener("message", o, !1);
    });
  }, n;
}();
class Ze {
  constructor(e, t, r) {
    B(this, "emitter");
    B(this, "container");
    B(this, "options");
    this.emitter = e, this.container = t, this.options = r || {};
  }
  createFrame() {
    const e = document.createElement("iframe");
    return e.name = "cfp-iframe", e.setAttribute("style", "position:absolute;top:0;left:0;width:100%;height:100%;border:0"), e;
  }
}
class _t extends Ze {
  constructor() {
    super(...arguments);
    B(this, "parent");
  }
  async play(t, r) {
    return new Promise(async (a) => {
      const i = this.options.presentationAnimationEngineIframeUrl ? this.options.presentationAnimationEngineIframeUrl : `${this.options.engineBaseUrl ? this.options.engineBaseUrl : ""}/cf-player/presentation-engine/index.html`, o = await new k({
        container: this.container,
        // @ts-ignore
        frame: this.createFrame(),
        url: i,
        model: {
          playMetas: t.animation,
          defaultPage: r.defaultPage ? r.defaultPage : 1,
          defaultStep: r.defaultStep ? r.defaultStep : 1
        }
      });
      let s = !1;
      o.on("paginationChange", (c) => {
        this.emitter.emit("paginationChange", Object.assign(c, { total: t.page })), s || (s = !0, a());
      }), this.parent = o;
    });
  }
  async prev() {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    await this.parent.get("prev");
  }
  async next() {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    await this.parent.get("next");
  }
  async goto(t) {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    t.step = t.step ? t.step : 1, this.parent.call("goto", t);
  }
  async destroy() {
    this.parent && this.parent.destroy();
  }
}
const I = /* @__PURE__ */ new WeakMap(), L = /* @__PURE__ */ new WeakMap(), z = /* @__PURE__ */ new WeakMap(), ce = Symbol("anyProducer"), Ne = Promise.resolve(), ue = Symbol("listenerAdded"), fe = Symbol("listenerRemoved");
let de = !1, _e = !1;
const he = (n) => typeof n == "string" || typeof n == "symbol" || typeof n == "number";
function N(n) {
  if (!he(n))
    throw new TypeError("`eventName` must be a string, symbol, or number");
}
function ne(n) {
  if (typeof n != "function")
    throw new TypeError("listener must be a function");
}
function X(n, e) {
  const t = L.get(n);
  if (t.has(e))
    return t.get(e);
}
function Q(n, e) {
  const t = he(e) ? e : ce, r = z.get(n);
  if (r.has(t))
    return r.get(t);
}
function Mt(n, e, t) {
  const r = z.get(n);
  if (r.has(e))
    for (const a of r.get(e))
      a.enqueue(t);
  if (r.has(ce)) {
    const a = Promise.all([e, t]);
    for (const i of r.get(ce))
      i.enqueue(a);
  }
}
function Xe(n, e) {
  e = Array.isArray(e) ? e : [e];
  let t = !1, r = () => {
  }, a = [];
  const i = {
    enqueue(o) {
      a.push(o), r();
    },
    finish() {
      t = !0, r();
    }
  };
  for (const o of e) {
    let s = Q(n, o);
    s || (s = /* @__PURE__ */ new Set(), z.get(n).set(o, s)), s.add(i);
  }
  return {
    async next() {
      return a ? a.length === 0 ? t ? (a = void 0, this.next()) : (await new Promise((o) => {
        r = o;
      }), this.next()) : {
        done: !1,
        value: await a.shift()
      } : { done: !0 };
    },
    async return(o) {
      a = void 0;
      for (const s of e) {
        const c = Q(n, s);
        c && (c.delete(i), c.size === 0 && z.get(n).delete(s));
      }
      return r(), arguments.length > 0 ? { done: !0, value: await o } : { done: !0 };
    },
    [Symbol.asyncIterator]() {
      return this;
    }
  };
}
function Ye(n) {
  if (n === void 0)
    return je;
  if (!Array.isArray(n))
    throw new TypeError("`methodNames` must be an array of strings");
  for (const e of n)
    if (!je.includes(e))
      throw typeof e != "string" ? new TypeError("`methodNames` element must be a string") : new Error(`${e} is not Emittery method`);
  return n;
}
const Y = (n) => n === ue || n === fe;
function re(n, e, t) {
  if (Y(e))
    try {
      de = !0, n.emit(e, t);
    } finally {
      de = !1;
    }
}
class V {
  static mixin(e, t) {
    return t = Ye(t), (r) => {
      if (typeof r != "function")
        throw new TypeError("`target` must be function");
      for (const o of t)
        if (r.prototype[o] !== void 0)
          throw new Error(`The property \`${o}\` already exists on \`target\``);
      function a() {
        return Object.defineProperty(this, e, {
          enumerable: !1,
          value: new V()
        }), this[e];
      }
      Object.defineProperty(r.prototype, e, {
        enumerable: !1,
        get: a
      });
      const i = (o) => function(...s) {
        return this[e][o](...s);
      };
      for (const o of t)
        Object.defineProperty(r.prototype, o, {
          enumerable: !1,
          value: i(o)
        });
      return r;
    };
  }
  static get isDebugEnabled() {
    var t;
    if (typeof ((t = globalThis.process) == null ? void 0 : t.env) != "object")
      return _e;
    const { env: e } = globalThis.process ?? { env: {} };
    return e.DEBUG === "emittery" || e.DEBUG === "*" || _e;
  }
  static set isDebugEnabled(e) {
    _e = e;
  }
  constructor(e = {}) {
    I.set(this, /* @__PURE__ */ new Set()), L.set(this, /* @__PURE__ */ new Map()), z.set(this, /* @__PURE__ */ new Map()), z.get(this).set(ce, /* @__PURE__ */ new Set()), this.debug = e.debug ?? {}, this.debug.enabled === void 0 && (this.debug.enabled = !1), this.debug.logger || (this.debug.logger = (t, r, a, i) => {
      try {
        i = JSON.stringify(i);
      } catch {
        i = `Object with the following keys failed to stringify: ${Object.keys(i).join(",")}`;
      }
      (typeof a == "symbol" || typeof a == "number") && (a = a.toString());
      const o = /* @__PURE__ */ new Date(), s = `${o.getHours()}:${o.getMinutes()}:${o.getSeconds()}.${o.getMilliseconds()}`;
      console.log(`[${s}][emittery:${t}][${r}] Event Name: ${a}
	data: ${i}`);
    });
  }
  logIfDebugEnabled(e, t, r) {
    (V.isDebugEnabled || this.debug.enabled) && this.debug.logger(e, this.debug.name, t, r);
  }
  on(e, t) {
    ne(t), e = Array.isArray(e) ? e : [e];
    for (const r of e) {
      N(r);
      let a = X(this, r);
      a || (a = /* @__PURE__ */ new Set(), L.get(this).set(r, a)), a.add(t), this.logIfDebugEnabled("subscribe", r, void 0), Y(r) || re(this, ue, { eventName: r, listener: t });
    }
    return this.off.bind(this, e, t);
  }
  off(e, t) {
    ne(t), e = Array.isArray(e) ? e : [e];
    for (const r of e) {
      N(r);
      const a = X(this, r);
      a && (a.delete(t), a.size === 0 && L.get(this).delete(r)), this.logIfDebugEnabled("unsubscribe", r, void 0), Y(r) || re(this, fe, { eventName: r, listener: t });
    }
  }
  once(e) {
    let t;
    const r = new Promise((a) => {
      t = this.on(e, (i) => {
        t(), a(i);
      });
    });
    return r.off = t, r;
  }
  events(e) {
    e = Array.isArray(e) ? e : [e];
    for (const t of e)
      N(t);
    return Xe(this, e);
  }
  async emit(e, t) {
    if (N(e), Y(e) && !de)
      throw new TypeError("`eventName` cannot be meta event `listenerAdded` or `listenerRemoved`");
    this.logIfDebugEnabled("emit", e, t), Mt(this, e, t);
    const r = X(this, e) ?? /* @__PURE__ */ new Set(), a = I.get(this), i = [...r], o = Y(e) ? [] : [...a];
    await Ne, await Promise.all([
      ...i.map(async (s) => {
        if (r.has(s))
          return s(t);
      }),
      ...o.map(async (s) => {
        if (a.has(s))
          return s(e, t);
      })
    ]);
  }
  async emitSerial(e, t) {
    if (N(e), Y(e) && !de)
      throw new TypeError("`eventName` cannot be meta event `listenerAdded` or `listenerRemoved`");
    this.logIfDebugEnabled("emitSerial", e, t);
    const r = X(this, e) ?? /* @__PURE__ */ new Set(), a = I.get(this), i = [...r], o = [...a];
    await Ne;
    for (const s of i)
      r.has(s) && await s(t);
    for (const s of o)
      a.has(s) && await s(e, t);
  }
  onAny(e) {
    return ne(e), this.logIfDebugEnabled("subscribeAny", void 0, void 0), I.get(this).add(e), re(this, ue, { listener: e }), this.offAny.bind(this, e);
  }
  anyEvent() {
    return Xe(this);
  }
  offAny(e) {
    ne(e), this.logIfDebugEnabled("unsubscribeAny", void 0, void 0), re(this, fe, { listener: e }), I.get(this).delete(e);
  }
  clearListeners(e) {
    e = Array.isArray(e) ? e : [e];
    for (const t of e)
      if (this.logIfDebugEnabled("clear", t, void 0), he(t)) {
        const r = X(this, t);
        r && r.clear();
        const a = Q(this, t);
        if (a) {
          for (const i of a)
            i.finish();
          a.clear();
        }
      } else {
        I.get(this).clear();
        for (const [r, a] of L.get(this).entries())
          a.clear(), L.get(this).delete(r);
        for (const [r, a] of z.get(this).entries()) {
          for (const i of a)
            i.finish();
          a.clear(), z.get(this).delete(r);
        }
      }
  }
  listenerCount(e) {
    var r, a, i;
    e = Array.isArray(e) ? e : [e];
    let t = 0;
    for (const o of e) {
      if (he(o)) {
        t += I.get(this).size + (((r = X(this, o)) == null ? void 0 : r.size) ?? 0) + (((a = Q(this, o)) == null ? void 0 : a.size) ?? 0) + (((i = Q(this)) == null ? void 0 : i.size) ?? 0);
        continue;
      }
      o !== void 0 && N(o), t += I.get(this).size;
      for (const s of L.get(this).values())
        t += s.size;
      for (const s of z.get(this).values())
        t += s.size;
    }
    return t;
  }
  bindMethods(e, t) {
    if (typeof e != "object" || e === null)
      throw new TypeError("`target` must be an object");
    t = Ye(t);
    for (const r of t) {
      if (e[r] !== void 0)
        throw new Error(`The property \`${r}\` already exists on \`target\``);
      Object.defineProperty(e, r, {
        enumerable: !1,
        value: this[r].bind(this)
      });
    }
  }
}
const je = Object.getOwnPropertyNames(V.prototype).filter((n) => n !== "constructor");
Object.defineProperty(V, "listenerAdded", {
  value: ue,
  writable: !1,
  enumerable: !0,
  configurable: !1
});
Object.defineProperty(V, "listenerRemoved", {
  value: fe,
  writable: !1,
  enumerable: !0,
  configurable: !1
});
class St extends Ze {
  constructor() {
    super(...arguments);
    B(this, "postmate");
  }
  async play(t, r) {
    return new Promise(async (a) => {
      const i = this.options.imageEngineIframeUrl ? this.options.imageEngineIframeUrl : `${this.options.engineBaseUrl ? this.options.engineBaseUrl : ""}/cf-player/image-engine/index.html`, o = await new k({
        container: this.container,
        // @ts-ignore
        frame: this.createFrame(),
        url: i,
        model: {
          metas: t,
          defaultPage: r.defaultPage ? r.defaultPage : 1,
          vertical: r.vertical ? r.vertical : !1
        }
      });
      let s = !1;
      o.on("paginationChange", (c) => {
        console.warn("paginationChange"), this.emitter.emit("paginationChange", c), s || (s = !0, setTimeout(() => {
          console.warn("played"), a();
        }, 500));
      }), this.postmate = o;
    });
  }
  async prev() {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    await this.postmate.get("prev");
  }
  async next() {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    await this.postmate.get("next");
  }
  async goto(t) {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    this.postmate.call("goto", t);
  }
  async destroy() {
    this.postmate && this.postmate.destroy();
  }
}
function Ct(n) {
  return rt() ? (at(n), !0) : !1;
}
function He(n) {
  return typeof n == "function" ? n() : ot(n);
}
const zt = typeof window < "u" && typeof document < "u";
typeof WorkerGlobalScope < "u" && globalThis instanceof WorkerGlobalScope;
const kt = zt ? window : void 0;
function Ue(n) {
  var e;
  const t = He(n);
  return (e = t == null ? void 0 : t.$el) != null ? e : t;
}
function It() {
  const n = K(!1), e = it();
  return e && Ie(() => {
    n.value = !0;
  }, e), n;
}
function Tt(n) {
  const e = It();
  return Fe(() => (e.value, !!n()));
}
function Dt(n, e, t = {}) {
  const { window: r = kt, ...a } = t;
  let i;
  const o = Tt(() => r && "ResizeObserver" in r), s = () => {
    i && (i.disconnect(), i = void 0);
  }, c = Fe(() => {
    const m = He(n);
    return Array.isArray(m) ? m.map((w) => Ue(w)) : [Ue(m)];
  }), p = Ge(
    c,
    (m) => {
      if (s(), o.value && r) {
        i = new ResizeObserver(e);
        for (const w of m)
          w && i.observe(w, a);
      }
    },
    { immediate: !0, flush: "post" }
  ), y = () => {
    s(), p();
  };
  return Ct(y), {
    isSupported: o,
    stop: y
  };
}
var P = function() {
  return P = Object.assign || function(e) {
    for (var t, r = 1, a = arguments.length; r < a; r++) {
      t = arguments[r];
      for (var i in t) Object.prototype.hasOwnProperty.call(t, i) && (e[i] = t[i]);
    }
    return e;
  }, P.apply(this, arguments);
};
typeof window < "u" && (window.NodeList && !NodeList.prototype.forEach && (NodeList.prototype.forEach = Array.prototype.forEach), typeof window.CustomEvent != "function" && (window.CustomEvent = function(e, t) {
  t = t || { bubbles: !1, cancelable: !1, detail: null };
  var r = document.createEvent("CustomEvent");
  return r.initCustomEvent(e, t.bubbles, t.cancelable, t.detail), r;
}));
function Je(n, e) {
  for (var t = n.length; t--; )
    if (n[t].pointerId === e.pointerId)
      return t;
  return -1;
}
function Te(n, e) {
  var t;
  if (e.touches) {
    t = 0;
    for (var r = 0, a = e.touches; r < a.length; r++) {
      var i = a[r];
      i.pointerId = t++, Te(n, i);
    }
    return;
  }
  t = Je(n, e), t > -1 && n.splice(t, 1), n.push(e);
}
function Lt(n, e) {
  if (e.touches) {
    for (; n.length; )
      n.pop();
    return;
  }
  var t = Je(n, e);
  t > -1 && n.splice(t, 1);
}
function We(n) {
  n = n.slice(0);
  for (var e = n.pop(), t; t = n.pop(); )
    e = {
      clientX: (t.clientX - e.clientX) / 2 + e.clientX,
      clientY: (t.clientY - e.clientY) / 2 + e.clientY
    };
  return e;
}
function Me(n) {
  if (n.length < 2)
    return 0;
  var e = n[0], t = n[1];
  return Math.sqrt(Math.pow(Math.abs(t.clientX - e.clientX), 2) + Math.pow(Math.abs(t.clientY - e.clientY), 2));
}
var ee = {
  down: "mousedown",
  move: "mousemove",
  up: "mouseup mouseleave"
};
typeof window < "u" && (typeof window.PointerEvent == "function" ? ee = {
  down: "pointerdown",
  move: "pointermove",
  up: "pointerup pointerleave pointercancel"
} : typeof window.TouchEvent == "function" && (ee = {
  down: "touchstart",
  move: "touchmove",
  up: "touchend touchcancel"
}));
function Se(n, e, t, r) {
  ee[n].split(" ").forEach(function(a) {
    e.addEventListener(a, t, r);
  });
}
function Ce(n, e, t) {
  ee[n].split(" ").forEach(function(r) {
    e.removeEventListener(r, t);
  });
}
var Rt = typeof document < "u" && !!document.documentMode, ze;
function Vt() {
  return ze || (ze = document.createElement("div").style);
}
var qe = ["webkit", "moz", "ms"], ae = {};
function Le(n) {
  if (ae[n])
    return ae[n];
  var e = Vt();
  if (n in e)
    return ae[n] = n;
  for (var t = n[0].toUpperCase() + n.slice(1), r = qe.length; r--; ) {
    var a = "".concat(qe[r]).concat(t);
    if (a in e)
      return ae[n] = a;
  }
}
function oe(n, e) {
  return parseFloat(e[Le(n)]) || 0;
}
function ie(n, e, t) {
  t === void 0 && (t = window.getComputedStyle(n));
  var r = e === "border" ? "Width" : "";
  return {
    left: oe("".concat(e, "Left").concat(r), t),
    right: oe("".concat(e, "Right").concat(r), t),
    top: oe("".concat(e, "Top").concat(r), t),
    bottom: oe("".concat(e, "Bottom").concat(r), t)
  };
}
function j(n, e, t) {
  n.style[Le(e)] = t;
}
function $t(n, e) {
  var t = Le("transform");
  j(n, "transition", "".concat(t, " ").concat(e.duration, "ms ").concat(e.easing));
}
function Bt(n, e, t) {
  var r = e.x, a = e.y, i = e.scale, o = e.isSVG;
  if (j(n, "transform", "scale(".concat(i, ") translate(").concat(r, "px, ").concat(a, "px)")), o && Rt) {
    var s = window.getComputedStyle(n).getPropertyValue("transform");
    n.setAttribute("transform", s);
  }
}
function ke(n) {
  var e = n.parentNode, t = window.getComputedStyle(n), r = window.getComputedStyle(e), a = n.getBoundingClientRect(), i = e.getBoundingClientRect();
  return {
    elem: {
      style: t,
      width: a.width,
      height: a.height,
      top: a.top,
      bottom: a.bottom,
      left: a.left,
      right: a.right,
      margin: ie(n, "margin", t),
      border: ie(n, "border", t)
    },
    parent: {
      style: r,
      width: i.width,
      height: i.height,
      top: i.top,
      bottom: i.bottom,
      left: i.left,
      right: i.right,
      padding: ie(e, "padding", r),
      border: ie(e, "border", r)
    }
  };
}
function Nt(n) {
  var e = n.ownerDocument, t = n.parentNode;
  return e && t && e.nodeType === 9 && t.nodeType === 1 && e.documentElement.contains(t);
}
function Xt(n) {
  return (n.getAttribute("class") || "").trim();
}
function Yt(n, e) {
  return n.nodeType === 1 && " ".concat(Xt(n), " ").indexOf(" ".concat(e, " ")) > -1;
}
function jt(n, e) {
  for (var t = n; t != null; t = t.parentNode)
    if (Yt(t, e.excludeClass) || e.exclude.indexOf(t) > -1)
      return !0;
  return !1;
}
var Ut = /^http:[\w\.\/]+svg$/;
function Wt(n) {
  return Ut.test(n.namespaceURI) && n.nodeName.toLowerCase() !== "svg";
}
function qt(n) {
  var e = {};
  for (var t in n)
    n.hasOwnProperty(t) && (e[t] = n[t]);
  return e;
}
var Ke = {
  animate: !1,
  canvas: !1,
  cursor: "move",
  disablePan: !1,
  disableZoom: !1,
  disableXAxis: !1,
  disableYAxis: !1,
  duration: 200,
  easing: "ease-in-out",
  exclude: [],
  excludeClass: "panzoom-exclude",
  handleStartEvent: function(n) {
    n.preventDefault(), n.stopPropagation();
  },
  maxScale: 4,
  minScale: 0.125,
  overflow: "hidden",
  panOnlyWhenZoomed: !1,
  pinchAndPan: !1,
  relative: !1,
  setTransform: Bt,
  startX: 0,
  startY: 0,
  startScale: 1,
  step: 0.3,
  touchAction: "none"
};
function Qe(n, e) {
  if (!n)
    throw new Error("Panzoom requires an element as an argument");
  if (n.nodeType !== 1)
    throw new Error("Panzoom requires an element with a nodeType of 1");
  if (!Nt(n))
    throw new Error("Panzoom should be called on elements that have been attached to the DOM");
  e = P(P({}, Ke), e);
  var t = Wt(n), r = n.parentNode;
  r.style.overflow = e.overflow, r.style.userSelect = "none", r.style.touchAction = e.touchAction, (e.canvas ? r : n).style.cursor = e.cursor, n.style.userSelect = "none", n.style.touchAction = e.touchAction, j(n, "transformOrigin", typeof e.origin == "string" ? e.origin : t ? "0 0" : "50% 50%");
  function a() {
    r.style.overflow = "", r.style.userSelect = "", r.style.touchAction = "", r.style.cursor = "", n.style.cursor = "", n.style.userSelect = "", n.style.touchAction = "", j(n, "transformOrigin", "");
  }
  function i(l) {
    l === void 0 && (l = {});
    for (var f in l)
      l.hasOwnProperty(f) && (e[f] = l[f]);
    (l.hasOwnProperty("cursor") || l.hasOwnProperty("canvas")) && (r.style.cursor = n.style.cursor = "", (e.canvas ? r : n).style.cursor = e.cursor), l.hasOwnProperty("overflow") && (r.style.overflow = l.overflow), l.hasOwnProperty("touchAction") && (r.style.touchAction = l.touchAction, n.style.touchAction = l.touchAction);
  }
  var o = 0, s = 0, c = 1, p = !1;
  $(e.startScale, { animate: !1, force: !0 }), setTimeout(function() {
    M(e.startX, e.startY, { animate: !1, force: !0 });
  });
  function y(l, f, h) {
    if (!h.silent) {
      var v = new CustomEvent(l, { detail: f });
      n.dispatchEvent(v);
    }
  }
  function m(l, f, h) {
    var v = { x: o, y: s, scale: c, isSVG: t, originalEvent: h };
    return requestAnimationFrame(function() {
      typeof f.animate == "boolean" && (f.animate ? $t(n, f) : j(n, "transition", "none")), f.setTransform(n, v, f), y(l, v, f), y("panzoomchange", v, f);
    }), v;
  }
  function w(l, f, h, v) {
    var u = P(P({}, e), v), g = { x: o, y: s, opts: u };
    if (!u.force && (u.disablePan || u.panOnlyWhenZoomed && c === u.startScale))
      return g;
    if (l = parseFloat(l), f = parseFloat(f), u.disableXAxis || (g.x = (u.relative ? o : 0) + l), u.disableYAxis || (g.y = (u.relative ? s : 0) + f), u.contain) {
      var d = ke(n), O = d.elem.width / c, C = d.elem.height / c, Z = O * h, H = C * h, T = (Z - O) / 2, D = (H - C) / 2;
      if (u.contain === "inside") {
        var Ee = (-d.elem.margin.left - d.parent.padding.left + T) / h, Pe = (d.parent.width - Z - d.parent.padding.left - d.elem.margin.left - d.parent.border.left - d.parent.border.right + T) / h;
        g.x = Math.max(Math.min(g.x, Pe), Ee);
        var xe = (-d.elem.margin.top - d.parent.padding.top + D) / h, Oe = (d.parent.height - H - d.parent.padding.top - d.elem.margin.top - d.parent.border.top - d.parent.border.bottom + D) / h;
        g.y = Math.max(Math.min(g.y, Oe), xe);
      } else if (u.contain === "outside") {
        var Ee = (-(Z - d.parent.width) - d.parent.padding.left - d.parent.border.left - d.parent.border.right + T) / h, Pe = (T - d.parent.padding.left) / h;
        g.x = Math.max(Math.min(g.x, Pe), Ee);
        var xe = (-(H - d.parent.height) - d.parent.padding.top - d.parent.border.top - d.parent.border.bottom + D) / h, Oe = (D - d.parent.padding.top) / h;
        g.y = Math.max(Math.min(g.y, Oe), xe);
      }
    }
    return u.roundPixels && (g.x = Math.round(g.x), g.y = Math.round(g.y)), g;
  }
  function A(l, f) {
    var h = P(P({}, e), f), v = { scale: c, opts: h };
    if (!h.force && h.disableZoom)
      return v;
    var u = e.minScale, g = e.maxScale;
    if (h.contain) {
      var d = ke(n), O = d.elem.width / c, C = d.elem.height / c;
      if (O > 1 && C > 1) {
        var Z = d.parent.width - d.parent.border.left - d.parent.border.right, H = d.parent.height - d.parent.border.top - d.parent.border.bottom, T = Z / O, D = H / C;
        e.contain === "inside" ? g = Math.min(g, T, D) : e.contain === "outside" && (u = Math.max(u, T, D));
      }
    }
    return v.scale = Math.min(Math.max(l, u), g), v;
  }
  function M(l, f, h, v) {
    var u = w(l, f, c, h);
    return o !== u.x || s !== u.y ? (o = u.x, s = u.y, m("panzoompan", u.opts, v)) : { x: o, y: s, scale: c, isSVG: t, originalEvent: v };
  }
  function $(l, f, h) {
    var v = A(l, f), u = v.opts;
    if (!(!u.force && u.disableZoom)) {
      l = v.scale;
      var g = o, d = s;
      if (u.focal) {
        var O = u.focal;
        g = (O.x / l - O.x / c + o * l) / l, d = (O.y / l - O.y / c + s * l) / l;
      }
      var C = w(g, d, l, { relative: !1, force: !0 });
      return o = C.x, s = C.y, c = l, m("panzoomzoom", u, h);
    }
  }
  function te(l, f) {
    var h = P(P(P({}, e), { animate: !0 }), f);
    return $(c * Math.exp((l ? 1 : -1) * h.step), h);
  }
  function pe(l) {
    return te(!0, l);
  }
  function ge(l) {
    return te(!1, l);
  }
  function U(l, f, h, v) {
    var u = ke(n), g = {
      width: u.parent.width - u.parent.padding.left - u.parent.padding.right - u.parent.border.left - u.parent.border.right,
      height: u.parent.height - u.parent.padding.top - u.parent.padding.bottom - u.parent.border.top - u.parent.border.bottom
    }, d = f.clientX - u.parent.left - u.parent.padding.left - u.parent.border.left - u.elem.margin.left, O = f.clientY - u.parent.top - u.parent.padding.top - u.parent.border.top - u.elem.margin.top;
    t || (d -= u.elem.width / c / 2, O -= u.elem.height / c / 2);
    var C = {
      x: d / g.width * (g.width * l),
      y: O / g.height * (g.height * l)
    };
    return $(l, P(P({}, h), { animate: !1, focal: C }), v);
  }
  function ve(l, f) {
    l.preventDefault();
    var h = P(P(P({}, e), f), { animate: !1 }), v = l.deltaY === 0 && l.deltaX ? l.deltaX : l.deltaY, u = v < 0 ? 1 : -1, g = A(c * Math.exp(u * h.step / 3), h).scale;
    return U(g, l, h, l);
  }
  function W(l) {
    var f = P(P(P({}, e), { animate: !0, force: !0 }), l);
    c = A(f.startScale, f).scale;
    var h = w(f.startX, f.startY, c, f);
    return o = h.x, s = h.y, m("panzoomreset", f);
  }
  var _, q, F, G, b, E, S = [];
  function me(l) {
    if (!jt(l.target, e)) {
      Te(S, l), p = !0, e.handleStartEvent(l), _ = o, q = s, y("panzoomstart", { x: o, y: s, scale: c, isSVG: t, originalEvent: l }, e);
      var f = We(S);
      F = f.clientX, G = f.clientY, b = c, E = Me(S);
    }
  }
  function ye(l) {
    if (!(!p || _ === void 0 || q === void 0 || F === void 0 || G === void 0)) {
      Te(S, l);
      var f = We(S), h = S.length > 1, v = c;
      if (h) {
        E === 0 && (E = Me(S));
        var u = Me(S) - E;
        v = A(u * e.step / 80 + b).scale, U(v, f, { animate: !1 }, l);
      }
      (!h || e.pinchAndPan) && M(_ + (f.clientX - F) / v, q + (f.clientY - G) / v, {
        animate: !1
      }, l);
    }
  }
  function we(l) {
    S.length === 1 && y("panzoomend", { x: o, y: s, scale: c, isSVG: t, originalEvent: l }, e), Lt(S, l), p && (p = !1, _ = q = F = G = void 0);
  }
  var be = !1;
  function Re() {
    be || (be = !0, Se("down", e.canvas ? r : n, me), Se("move", document, ye, { passive: !0 }), Se("up", document, we, { passive: !0 }));
  }
  function et() {
    be = !1, Ce("down", e.canvas ? r : n, me), Ce("move", document, ye), Ce("up", document, we);
  }
  return e.noBind || Re(), {
    bind: Re,
    destroy: et,
    eventNames: ee,
    getPan: function() {
      return { x: o, y: s };
    },
    getScale: function() {
      return c;
    },
    getOptions: function() {
      return qt(e);
    },
    handleDown: me,
    handleMove: ye,
    handleUp: we,
    pan: M,
    reset: W,
    resetStyle: a,
    setOptions: i,
    setStyle: function(l, f) {
      return j(n, l, f);
    },
    zoom: $,
    zoomIn: pe,
    zoomOut: ge,
    zoomToPoint: U,
    zoomWithWheel: ve
  };
}
Qe.defaultOptions = Ke;
const Ft = {
  key: 0,
  ref: "boardEl",
  class: "cf-player__board"
}, Gt = {
  key: 1,
  class: "cf-player__mask"
}, Jt = /* @__PURE__ */ st({
  __name: "Player",
  props: {
    file: {},
    engine: { default: "image" },
    defaultPage: { default: 1 },
    defaultStep: { default: 1 },
    vertical: { type: Boolean, default: !1 },
    dark: { type: Boolean, default: !1 },
    enableBoard: { type: Boolean, default: !1 },
    enableZoom: { type: Boolean, default: !1 },
    engineBaseUrl: {},
    imageEngineIframeUrl: {},
    presentationAnimationEngineIframeUrl: {}
  },
  emits: ["paginationChange"],
  setup(n, { expose: e, emit: t }) {
    const r = n, a = t, i = K(null), o = K(null), s = K(null), c = Ae({}), p = Ae({
      width: 0,
      height: 0
    }), y = Ae({
      width: 0,
      height: 0
    }), m = Ve(null), w = Ve(null), A = new V();
    A.on("paginationChange", (b) => {
      a("paginationChange", b);
    });
    const M = K(!1);
    Ge([() => r.file, () => r.engine], async () => {
      if (r.file) {
        if (typeof r.file == "string")
          throw new Error("File id is not supported, but coming soon...");
        w.value = r.file, w.value && (W(), await lt(), M.value = !0, await U(w.value, r.engine), await m.value.play(ct(w.value), {
          defaultPage: r.defaultPage,
          defaultStep: r.defaultStep,
          vertical: r.vertical
        }), M.value = !1);
      }
    }, { immediate: !0 });
    const $ = async () => {
      if (!m.value)
        throw new Error("No engine.");
      await m.value.prev();
    }, te = async () => {
      if (!m.value)
        throw new Error("No engine.");
      await m.value.next();
    }, pe = async (b) => {
      if (!m.value)
        throw new Error("No engine.");
      await m.value.goto(b);
    }, ge = () => {
      if (!w.value || !w.value.page || !w.value.thumb)
        return [];
      const b = [];
      for (let E = 1; E <= w.value.page; E++)
        b.push({ page: E, url: w.value.thumb + E });
      return b;
    }, U = async (b, E) => {
      if (await ve(), b.type === "Presentation")
        E === "image" ? m.value = new St(A, s.value, r) : E === "presentation" && (m.value = new _t(A, s.value, r));
      else throw b.type === "Word" ? new Error("Coming soon.") : b.type === "PDF" ? new Error("Coming soon.") : new Error("Not support file type.");
    }, ve = async () => {
      m.value && (await m.value.destroy(), m.value = null);
    }, W = () => {
      const b = 1.7777777777777777;
      p.width = i.value.clientWidth, p.height = i.value.clientHeight, console.log(`[cf-player] resize viewport, width ${p.width}, height ${p.height}`), p.width / p.height > b ? (y.width = Math.round(p.height * b), y.height = p.height, c.width = `${y.width}px`, c.height = `${p.height}px`, c.top = "0", c.left = `${Math.round((p.width - y.width) / 2)}px`) : (y.width = p.width, y.height = Math.round(p.width * (1 / b)), c.width = `${p.width}px`, c.height = `${y.height}px`, c.top = `${Math.round(p.height - y.height) / 2}px`, c.left = "0");
    };
    Ie(() => {
      W();
    }), Dt(i, () => {
      W();
    });
    let _;
    return Ie(() => {
      r.enableZoom && (_ = Qe(o.value, {
        maxScale: 3,
        minScale: 0.4,
        origin: "50% 0%",
        animate: !1,
        // what ?
        handleStartEvent: () => {
        }
      }));
    }), e({
      prev: $,
      next: te,
      goto: pe,
      thumbs: ge,
      zoomIn: () => {
        !r.enableZoom || !_ || _.zoomIn();
      },
      zoomOut: () => {
        !r.enableZoom || !_ || _.zoomOut();
      },
      zoomReset: () => {
        !r.enableZoom || !_ || _.reset();
      }
    }), (b, E) => (se(), le("div", {
      ref_key: "playerEl",
      ref: i,
      class: $e(["cf-player", { "cf-player--dark": b.dark }])
    }, [
      J("div", {
        class: "cf-player__viewport",
        style: ut(c)
      }, [
        J("div", {
          ref_key: "layersEl",
          ref: o,
          class: "cf-player__layers"
        }, [
          J("div", {
            ref_key: "contentEl",
            ref: s,
            class: $e(["cf-player__content", [b.vertical ? "cf-player__content--vertical" : "cf-player__content--horizontal"]])
          }, null, 2),
          E[2] || (E[2] = J("div", { class: "cf-player__ground" }, null, -1)),
          b.enableBoard ? (se(), le("div", Ft, null, 512)) : Be("", !0),
          M.value ? (se(), le("div", Gt, [
            ft(mt),
            E[0] || (E[0] = dt()),
            E[1] || (E[1] = J("span", { class: "cf-player__mask__text" }, "文件加载中...", -1))
          ])) : Be("", !0)
        ], 512)
      ], 4)
    ], 2));
  }
});
export {
  Jt as CloudFilePlayer
};
